#ifndef _CORE_H_
#define _CORE_H_

#include <pspkernel.h>
#include <pspctrl.h>	//pads
#include <psprtc.h>		//realtimeclock

#include "../renderer/renderer.h"

void dump_threadstatus(void);

// FPS counter
class CTimer
{
	float m_CurrentMS;
	u64 m_LastTick;
	u32 m_TickFreq;
	int m_FrameCount;
	float m_FPS;

public:
	void 	Init();
	u64		Update();
	float 	GetFPS();
};

class CCtrlPad 
{
public:
	SceCtrlData m_Pad;
	int Old;
	int State;
	int Toggle;
	int Release;
	int Press;
	int Lx;
	int Ly;
	
	int Init(enum PspCtrlMode _mode = PSP_CTRL_MODE_ANALOG);
	int Update();
};


class CEngineCore
{
public:

	CCtrlPad	m_Pad;
	CTimer		m_Timer;

	//void* fbp0;
	//void* fbp1;
	//void* zbp;

	int dispBufferNumber;
	int initialized;

	static int SetupCallbacks(void);
	
	int Init(enum PspCtrlMode _ctrlmode = PSP_CTRL_MODE_ANALOG);
	int InitGFX();
	int Shutdown();
	int	UpdatePad();
	u64 Update();
	int StartFrame();
	int EndFrame();
	

private: 
			void 	audioCallback(void* buf, unsigned int length, void *userdata);
	static int 	exit_callback(int arg1, int arg2, void * common);
	static int 	callbackThread(SceSize args, void *argp);
}; 
#endif
