#include "defines.h" 
#include "Ball.h"
#include "../renderer/graphics.h"
#include "../maths/collide.h"
#include "../globals.h"

CBall::CBall()
{
	m_Pos.Set(SCREEN_WIDTH*0.5f, SCREEN_HEIGHT*0.5f);
	m_Vel.Set(0.25f,0.25f);
	m_Speeds.Set(0.25f,0.25f);
	m_HScale.Set(4,4);
	m_SpinAmt = 0.0f;
	m_AccVal = 0.00f;
}

bool CBall::Update(CPlayfield &_field, CPlayer &_p1, CPlayer &_p2 )
{
	m_Pos += m_Vel;
	
	if((m_Pos.y + m_HScale.y) > (_field.m_Pos.y + _field.m_HScale.y))
	{
		m_Pos.y = _field.m_Pos.y + _field.m_HScale.y - m_HScale.y;
		if(m_Vel.y > 0)
			m_Vel.y *= -1.0f;
		
	}
		
	if((m_Pos.y - m_HScale.y) < (_field.m_Pos.y - _field.m_HScale.y))
	{
		m_Pos.y = _field.m_Pos.y - _field.m_HScale.y + m_HScale.y;
		if(m_Vel.y < 0)
			m_Vel.y *= -1.0f;
	}
	
	//players
	if(BBoxCollide(m_Pos, m_HScale, _p1.m_Pos, _p1.m_HScale))
	{
		if(m_Vel.x < 0)
			{
				m_Vel.x *= -1.0f;
				m_Vel.x += m_AccVal;
				m_Vel.y += m_SpinAmt * _p1.m_LastVel.y;		
			}
	}
	if(BBoxCollide(m_Pos, m_HScale, _p2.m_Pos, _p2.m_HScale))
	{
		if(m_Vel.x > 0)
		{
			m_Vel.x *= -1.0f;
			m_Vel.x -= m_AccVal;
			m_Vel.y += m_SpinAmt * _p2.m_LastVel.y;
		}
	}
	
	// goals
	//P1 scores
	if((m_Pos.x + m_HScale.x) > (_field.m_Pos.x + _field.m_HScale.x))
	{
		m_Pos.Set(&_field.m_Pos);
		m_Vel.x *= -1;
		_p1.m_Score ++;		
		g_ToServe = 2;
	}
	//P2 scores
	if((m_Pos.x - m_HScale.x) < (_field.m_Pos.x - _field.m_HScale.x))
	{
		m_Pos.Set(&_field.m_Pos);
		m_Vel.x *= -1;
		_p2.m_Score ++;		
		g_ToServe = 1;
	}
	
	return 1;
}

bool CBall::Render()
{
	fillScreenRect(RGB(255,255,255), int(m_Pos.x-m_HScale.x), int(m_Pos.y-m_HScale.y), int(2*m_HScale.x), int(2*m_HScale.y));
	
	return 1;
}
