#include <stdlib.h>
#include "defines.h" 
#include "Player.h"
#include "../globals.h"
#include "../renderer/graphics.h"
#include "../maths/collide.h"

CPlayer::CPlayer()
{
	Init(0, 0);
	m_ScoreGamesWon = 0;
}

bool CPlayer::Init(int _playerNum, int _intelligence)
{
	m_Pos.Set(SCREEN_WIDTH*0.5f, SCREEN_HEIGHT*0.5f);
	m_Vel.Set(0,0);
	m_LastVel.Set(0,0);
	m_Speeds.Set(0.5f,0.5f);
	m_HScale.Set(4,16);
	m_Score = 0;
	m_Intelligence = _intelligence;
	m_PlayerNum = _playerNum;
	return 1;
}

bool CPlayer::Update(CPlayfield &_field, float _ballY)
{
	//if CPU controlled
	if(m_Intelligence != 0)
	{
		// rool to see if player moves (< half intelligence to think)
		if((rand()%m_Intelligence) == 0 )
		{
			if(g_ToServe == m_PlayerNum)
			{
				g_ToServe = 0;
			}
			//roll to see if movement stops
			if((rand()%m_Intelligence) < int(m_Intelligence * 0.1f))
				m_Vel.y  = 0;
			else
			{
				if(_ballY > m_Pos.y)
					m_Vel.y = m_Speeds.y;
				else					
					m_Vel.y = -m_Speeds.y;
			}
		}
		
	}

	m_Pos += m_Vel;
	
	if((m_Pos.y + m_HScale.y) > (_field.m_Pos.y + _field.m_HScale.y))
		m_Pos.y = _field.m_Pos.y + _field.m_HScale.y - m_HScale.y;
		
	if((m_Pos.y - m_HScale.y) < (_field.m_Pos.y - _field.m_HScale.y))
		m_Pos.y = _field.m_Pos.y - _field.m_HScale.y + m_HScale.y;
	
	m_LastVel = m_Vel;
	
	//only cut movement of not AI controlled
	if(m_Intelligence == 0)
		m_Vel.y = 0;
		
	return 1;
}

bool CPlayer::Render()
{
	fillScreenRect(RGB(255,255,255), int(m_Pos.x-m_HScale.x), int(m_Pos.y-m_HScale.y), int(2*m_HScale.x), int(2*m_HScale.y));
	
	return 1;
}
