#include "defines.h" 
#include "Playfield.h"
#include "../renderer/graphics.h"


CPlayfield::CPlayfield()
{
	m_Pos.Set(SCREEN_WIDTH*0.5f, SCREEN_HEIGHT*0.5);
	m_HScale.Set(SCREEN_WIDTH*0.5f-2, SCREEN_HEIGHT*0.5-2);
	m_P1Start.Set(m_Pos.x - m_HScale.x + 16, SCREEN_HEIGHT*0.5);
	m_P2Start.Set(m_Pos.x + m_HScale.x - 16, SCREEN_HEIGHT*0.5);
	m_Colour = RGB(255,255,255);
}

void CPlayfield::Init(float _x, float _y, float _w, float _h)
{
	m_Pos.Set(_x, _y);
	m_HScale.Set(_w, _h);
	m_P1Start.Set(m_Pos.x - m_HScale.x + 16, m_Pos.y);
	m_P2Start.Set(m_Pos.x + m_HScale.x - 16, m_Pos.y);
	m_Colour = RGB(255,255,255);
}

bool CPlayfield::Render()
{
	drawLineScreen(int(m_Pos.x-m_HScale.x), int(m_Pos.y-m_HScale.y), int(m_Pos.x-m_HScale.x), int(m_Pos.y+m_HScale.y), m_Colour);
	drawLineScreen(int(m_Pos.x-m_HScale.x), int(m_Pos.y+m_HScale.y), int(m_Pos.x+m_HScale.x), int(m_Pos.y+m_HScale.y), m_Colour);
	drawLineScreen(int(m_Pos.x+m_HScale.x), int(m_Pos.y+m_HScale.y), int(m_Pos.x+m_HScale.x), int(m_Pos.y-m_HScale.y), m_Colour);
	drawLineScreen(int(m_Pos.x+m_HScale.x), int(m_Pos.y-m_HScale.y), int(m_Pos.x-m_HScale.x), int(m_Pos.y-m_HScale.y), m_Colour);
	
	drawLineScreen(int(m_Pos.x), int(m_Pos.y-m_HScale.y), int(m_Pos.x), int(m_Pos.y+m_HScale.y), m_Colour);

	return 1;
}
