#ifndef _GLOBALS_H_
#define _GLOBALS_H_

#include "core/core.h"  
#include "renderer/text.h" 

#include "game/Playfield.h" 
#include "game/Player.h" 
#include "game/Ball.h" 

enum gametype {GT_SINGLE, GT_VS, GT_DEMO};

//globals
extern int done;
extern int Difficulty;
extern int CPUIntelligence;
extern int WinAt;
extern int	g_ToServe;

extern int selected1;
extern int selected2;
extern int maxselect;
extern int maxOption;
extern int maxPaused;
extern int g_Paused;

extern int (*g_pInput)	(void*);
extern int (*g_pLogic)	(void*);
extern int (*g_pRender)(void*);

int InputGame		(void* _arg);
int LogicGame		(void* _arg);
int RenderGame		(void* _arg);
int InputDemo		(void* _arg);
int LogicDemo		(void* _arg);
int NewGame(gametype _type);

extern CEngineCore g_Core;
extern CText 		g_Text;

extern CPlayfield 	Playfield;
extern CPlayer 	P1;
extern CPlayer 	P2;
extern CBall 		Ball;

#endif
