#ifndef _MATHS_H_
#define _MATHS_H_

//////////////////////////////
//	#defines - constants	//
//////////////////////////////
#define EQUALENOUGH 0.0001  

#define PI					(3.14159f)
#define PIOVER180			(0.017453277777777777777777777777778f)		//(PI/180.0f)
#define PIUNDER180			(57.295827908797774375395898255342f)		//(180.0f/PI)
#define ONEOVERRANDMAX		(0.000030518509475997192297128208258309f)

//////////////////
//	#includes	//
//////////////////

class vec2f;

#include <stdlib.h>
#include <math.h>
#include "vec2f.h"

//////////////////////////
//	#defines - macros	//
//////////////////////////
#ifndef MIN
#define MIN(a,b) ((a) < (b) ? (a) : (b))
#endif
#ifndef MAX
#define MAX(a,b) ((a) > (b) ? (a) : (b))
#endif

#define SQR(x) ((x)*(x))
#define SQRT(x) ((float)sqrt(x))

#define SIN(x) ((float)sin(x))
#define COS(x) ((float)cos(x))

//////////////////
//	functions	//
//////////////////
template< class T >
inline void SWAP( T& a, T& b )
{
    const T temp = a;
    a = b;
    b = temp;
}

//////////////
//	inlines	//
//////////////

// random
	// The following line must be at the start of the main function
	// srand(time(NULL));
	inline float random( void )
	{
		return ((float)rand())*ONEOVERRANDMAX;
	}


#endif