#include "menus.h"
#include "globals.h"
#include <stdio.h>
#include <psputils.h>

//==============================================================================
// MENU FUNCTIONS
//==============================================================================
//------------------------------------------------------------------------------
// Get Input
//------------------------------------------------------------------------------
int timer = 0;
int InputMenu(void* _arg)
{
	if(g_Core.m_Pad.State != 0) 
		timer = 0;
		
	if(g_Core.m_Pad.Press & PSP_CTRL_RIGHT)		{	selected1--;	}
	if(g_Core.m_Pad.Press & PSP_CTRL_LEFT)		{	selected1++;	}
	if(g_Core.m_Pad.Press & PSP_CTRL_SQUARE)	{	selected2--;	}
	if(g_Core.m_Pad.Press & PSP_CTRL_CIRCLE)	{	selected2++;	}
	if((g_Core.m_Pad.Press & PSP_CTRL_LTRIGGER)	|| (g_Core.m_Pad.Press & PSP_CTRL_RTRIGGER)	)
	{
		int s;
		if(g_Core.m_Pad.Press & PSP_CTRL_RTRIGGER)	
			s = selected2;
		if(g_Core.m_Pad.Press & PSP_CTRL_LTRIGGER)	
			s = selected1;
			
		switch(s)
		{
		case 0:
			g_pInput = &InputGame;
			g_pLogic = &LogicGame;
			g_pRender = &RenderGame;
			selected1 = 0;
			selected2 = 0;
			NewGame(GT_SINGLE);
			break;
		case 1:
			g_pInput = &InputGame;
			g_pLogic = &LogicGame;
			g_pRender = &RenderGame;
			selected1 = 0;
			selected2 = 0;
			NewGame(GT_VS);
			break;
		case 2:
			g_pInput = &InputOptions;
			g_pLogic = &LogicOptions;
			g_pRender = &RenderOptions;
			selected1 = 0;
			selected2 = 0;
			break;
		case 3:
			g_pInput = &InputAbout;
			g_pLogic = &LogicAbout;
			g_pRender = &RenderAbout;
			selected1 = 0;
			selected2 = 0;
			break;
		case 4:
			done = 1;
			break;
		default:	
			break;
		}
	}
	
		//Screen		
	if(g_Core.m_Pad.Press & PSP_CTRL_SELECT)
	{
		timeval s;
		timezone z;
		sceKernelLibcGettimeofday(&s, &z);
		
		char buf[64];
		sprintf(buf, "../../PHOTO/Pong+ [%ld].png", s.tv_sec);
		saveImage(buf, getVramDisplayBuffer(), SCREEN_WIDTH, SCREEN_HEIGHT, PSP_LINE_SIZE, 0);
	}

	return 1;
}

//------------------------------------------------------------------------------
// Think
//------------------------------------------------------------------------------
int LogicMenu(void* _arg)
{	
	// If theres a long wait, go into attract mode
	if(timer++ == 10000)
	{
		timer = 0;
		g_pInput = &InputDemo;
		g_pLogic = &LogicDemo;
		g_pRender = &RenderGame;
		selected1 = 0;
		selected2 = 0;
		NewGame(GT_DEMO);	
	}
	
	(selected1 > maxselect)?selected1 = 0:selected1=selected1;
	(selected1 < 0)?selected1 = maxselect:selected1=selected1;
	(selected2 > maxselect)?selected2 = 0:selected2=selected2;
	(selected2 < 0)?selected2 = maxselect:selected2=selected2;
		
	return 1;		
}

//------------------------------------------------------------------------------
// Draw
//------------------------------------------------------------------------------
int RenderMenu(void* _arg)
{
	//Render scene
	Playfield.Render();
	
	int t = 56;	
	int l = 72;	
	int p1x = (int)(SCREEN_WIDTH*0.5f-t);
	int p1y = (int)l;
	int p2x = (int)(SCREEN_WIDTH*0.5f+t);
	int p2y = (int)SCREEN_HEIGHT - l;
	int st = 10;
	
	//Render text
	g_Text.PrintVTB(p1x,p1y, 	 	"   Pong+");
	g_Text.PrintVTB(p1x-=2*st,p1y, 	"%s%sNew Game",		(selected1==0)?"^":" ", (selected2==0)?"_ ":"  " );
	g_Text.PrintVTB(p1x-=st,p1y, 	"%s%sNew Solo Game",(selected1==1)?"^":" ", (selected2==1)?"_ ":"  " );
	g_Text.PrintVTB(p1x-=st,p1y, 	"%s%sOptions",	 	(selected1==2)?"^":" ", (selected2==2)?"_ ":"  " );
	g_Text.PrintVTB(p1x-=st,p1y, 	"%s%sAbout",	 	(selected1==3)?"^":" ", (selected2==3)?"_ ":"  " );
	g_Text.PrintVTB(p1x-=st,p1y, 	"%s%sExit",	 		(selected1==4)?"^":" ", (selected2==4)?"_ ":"  " );
	
	g_Text.PrintVBT(p2x,p2y, 	 	"   Pong+");
	g_Text.PrintVBT(p2x+=2*st,p2y, 	"%s%sNew Game",		(selected2==0)?"_":" ", (selected1==0)?"^ ":"  " );
	g_Text.PrintVBT(p2x+=st,p2y, 	"%s%sNew Vs Game",	(selected2==1)?"_":" ", (selected1==1)?"^ ":"  " );
	g_Text.PrintVBT(p2x+=st,p2y, 	"%s%sOptions",		(selected2==2)?"_":" ", (selected1==2)?"^ ":"  " );
	g_Text.PrintVBT(p2x+=st,p2y, 	"%s%sAbout",	 	(selected2==3)?"_":" ", (selected1==3)?"^ ":"  " );
	g_Text.PrintVBT(p2x+=st,p2y, 	"%s%sExit",	 		(selected2==4)?"_":" ", (selected1==4)?"^ ":"  " );
		
	g_Text.PrintVTB(8, 2, 							   "^ Player 1");
	g_Text.PrintVBT(SCREEN_WIDTH-16, SCREEN_HEIGHT-10, "_ Player 2");


	return 1;
}

//==============================================================================
// Options Menu Functions
//==============================================================================
int InputOptions	(void* _arg)
{
	int coarseTune = 5;
	float fineTune = 0.05f;
	float ufineTune = 0.005f;
	if(g_Core.m_Pad.Press & PSP_CTRL_RIGHT)		{	selected1--;	}
	if(g_Core.m_Pad.Press & PSP_CTRL_LEFT)		{	selected1++;	}
	if(g_Core.m_Pad.Press & PSP_CTRL_SQUARE)	{	selected2--;	}
	if(g_Core.m_Pad.Press & PSP_CTRL_CIRCLE)	{	selected2++;	}
	
	if((g_Core.m_Pad.Press & PSP_CTRL_DOWN))
	{
		if(selected1!=0)
			Difficulty = 0;
			
		switch(selected1)
		{
			case 0:
				Difficulty++; 
				break;
			case 1:
				WinAt++; 
				break;
			case 2:
				Ball.m_SpinAmt 	+= fineTune;
				break;
			case 3:
				Ball.m_AccVal 	+= ufineTune;
				break;
			case 4:
				P1.m_Speeds.y 	+= fineTune;
				P2.m_Speeds.y 	= P1.m_Speeds.y;
				break;
			case 5:
				CPUIntelligence += coarseTune;
				break;
			default:
				break;
		}
	}
	
	if((g_Core.m_Pad.Press & PSP_CTRL_UP))
	{
		if(selected1!=0)
			Difficulty = 0;
			
		switch(selected1)
		{
			case 0:
				Difficulty--; 
				break;
			case 1:
				WinAt--; 
				break;
			case 2:
				Ball.m_SpinAmt 	-= fineTune;
				break;
			case 3:
				Ball.m_AccVal 	-= ufineTune;
				break;
			case 4:
				P1.m_Speeds.y 	-= fineTune;
				P2.m_Speeds.y 	= P1.m_Speeds.y;
				break;
			case 5:
				CPUIntelligence -= coarseTune;
				break;
			default:
				break;
		}
	}
	
	if((g_Core.m_Pad.Press & PSP_CTRL_TRIANGLE))
	{
		if(selected2!=0)
			Difficulty = 0;
			
		switch(selected2)
		{
			case 0:
				Difficulty++; 
				break;
			case 1:
				WinAt++; 
				break;
			case 2:
				Ball.m_SpinAmt 	+= fineTune;
				break;
			case 3:
				Ball.m_AccVal 	+= ufineTune;
				break;
			case 4:
				P1.m_Speeds.y 	+= fineTune;
				P2.m_Speeds.y 	= P1.m_Speeds.y;
				break;
			case 5:
				CPUIntelligence += coarseTune;
				break;
			default:
				break;
		}
	}
		
	if((g_Core.m_Pad.Press & PSP_CTRL_CROSS))
	{
		if(selected2!=0)
			Difficulty = 0;
			
		switch(selected2)
		{
			case 0:
				Difficulty--; 
				break;
			case 1:
				WinAt--; 
				break;
			case 2:
				Ball.m_SpinAmt 	-= fineTune;
				break;
			case 3:
				Ball.m_AccVal 	-= ufineTune;
				break;
			case 4:
				P1.m_Speeds.y 	-= fineTune;
				P2.m_Speeds.y 	= P1.m_Speeds.y;
				break;
			case 5:
				CPUIntelligence -= coarseTune;
				break;
			default:
				break;
		}
	}
	
	if((g_Core.m_Pad.Press & PSP_CTRL_LTRIGGER)	|| (g_Core.m_Pad.Press & PSP_CTRL_RTRIGGER)	)
	{
		int s;
		if(g_Core.m_Pad.Press & PSP_CTRL_RTRIGGER)	
			s = selected2;
		if(g_Core.m_Pad.Press & PSP_CTRL_LTRIGGER)	
			s = selected1;
			
		switch(s)
		{
		case 6:
			g_pInput = &InputMenu;
			g_pLogic = &LogicMenu;
			g_pRender = &RenderMenu;
			selected1 = 0;
			selected2 = 0;
			break;
		default:	
			break;
		}
	}
	
	return 1;
}

int LogicOptions	(void* _arg)
{
	(selected1 > maxOption)?selected1 = 0:selected1=selected1;
	(selected1 < 0)?selected1 = maxOption:selected1=selected1;
	(selected2 > maxOption)?selected2 = 0:selected2=selected2;
	(selected2 < 0)?selected2 = maxOption:selected2=selected2;
	
	(Difficulty > 4)?Difficulty = 0:Difficulty=Difficulty;
	(Difficulty < 0)?Difficulty = 4:Difficulty=Difficulty;
	
	switch(Difficulty)
	{	
	case 1:
		WinAt 			= 3;
		Ball.m_SpinAmt	= 0;
		Ball.m_AccVal 	= 0;
		P1.m_Speeds.y 	= 0.5f;
		P2.m_Speeds.y 	= P1.m_Speeds.y;
		CPUIntelligence = 100;
		break;		
	case 2:
		WinAt 			= 5;
		Ball.m_SpinAmt	= 0.05f;
		Ball.m_AccVal 	= 0.001f;
		P1.m_Speeds.y 	= 0.5f;
		P2.m_Speeds.y 	= P1.m_Speeds.y;
		CPUIntelligence = 75;
		break;				
	case 3:
		WinAt 			= 7;
		Ball.m_SpinAmt	= 0.15;
		Ball.m_AccVal 	= 0.010;
		P1.m_Speeds.y 	= 0.75f;
		P2.m_Speeds.y 	= P1.m_Speeds.y;
		CPUIntelligence = 50;
		break;		
	case 4:
		WinAt 			= 9;
		Ball.m_SpinAmt	= 0.35;
		Ball.m_AccVal 	= 0.05;
		P1.m_Speeds.y 	= 1.0f;
		P2.m_Speeds.y 	= P1.m_Speeds.y;
		CPUIntelligence = 25;
		break;		
	default:
		break;		
	}
			
	return 1;		
}
int RenderOptions	(void* _arg)
{

	//Render scene
	Playfield.Render();
	
	int t = 56;	
	int l = 32;	
	int p1x = (int)(SCREEN_WIDTH*0.5f-t);
	int p1y = (int)l;
	int p2x = (int)(SCREEN_WIDTH*0.5f+t);
	int p2y = (int)SCREEN_HEIGHT - l;
	int st = 10;
	
	g_Text.PrintVTB(p1x, p1y, "OPTIONS");
	g_Text.PrintVBT(p2x, p2y, "OPTIONS");
	
	//Render text
	switch(Difficulty)
	{	
	case 1:
		g_Text.PrintVTB(p1x-=2*st, p1y, "%s%sPreset: Basic",		(selected1==0)?"^":" ", (selected2==0)?"_ ":"  ");
		g_Text.PrintVBT(p2x+=2*st, p2y, "%s%sPreset: Basic",		(selected2==0)?"_":" ", (selected1==0)?"^ ":"  ");
		break;
		
	case 2:
		g_Text.PrintVTB(p1x-=2*st, p1y, "%s%sPreset: Learn",		(selected1==0)?"^":" ", (selected2==0)?"_ ":"  ");
		g_Text.PrintVBT(p2x+=2*st, p2y, "%s%sPreset: Learn",		(selected2==0)?"_":" ", (selected1==0)?"^ ":"  ");
		break;
		
	case 3:
		g_Text.PrintVTB(p1x-=2*st, p1y, "%s%sPreset: Advance",	(selected1==0)?"^":" ", (selected2==0)?"_ ":"  ");
		g_Text.PrintVBT(p2x+=2*st, p2y, "%s%sPreset: Advance",	(selected2==0)?"_":" ", (selected1==0)?"^ ":"  ");
		break;
		
	case 4:
		g_Text.PrintVTB(p1x-=2*st, p1y, "%s%sPreset: Expert",		(selected1==0)?"^":" ", (selected2==0)?"_ ":"  ");
		g_Text.PrintVBT(p2x+=2*st, p2y, "%s%sPreset: Expert",		(selected2==0)?"_":" ", (selected1==0)?"^ ":"  ");	
		break;
		
	default:
		g_Text.PrintVTB(p1x-=2*st, p1y, "%s%sPreset: Custom",		(selected1==0)?"^":" ", (selected2==0)?"_ ":"  ");
		g_Text.PrintVBT(p2x+=2*st, p2y, "%s%sPreset: Custom",		(selected2==0)?"_":" ", (selected1==0)?"^ ":"  ");
		break;
	}

	g_Text.PrintVTB(p1x-=st,	p1y, "%s%sPoints to win: %02d",	(selected1==1)?"^":" ", (selected2==1)?"_ ":"  ", WinAt );
	g_Text.PrintVTB(p1x-=st, 	p1y, "%s%sBall Spin:     %2.3f",(selected1==2)?"^":" ", (selected2==2)?"_ ":"  ", Ball.m_SpinAmt);
	g_Text.PrintVTB(p1x-=st, 	p1y, "%s%sBat Spring:    %2.3f",(selected1==3)?"^":" ", (selected2==3)?"_ ":"  ", Ball.m_AccVal);
	g_Text.PrintVTB(p1x-=st, 	p1y, "%s%sBat Speed:     %2.3f",(selected1==4)?"^":" ", (selected2==4)?"_ ":"  ", P1.m_Speeds.y);
	g_Text.PrintVTB(p1x-=st, 	p1y, "%s%sCPU Ability:   %03d",	(selected1==5)?"^":" ", (selected2==5)?"_ ":"  ", CPUIntelligence);
	g_Text.PrintVTB(p1x-=st, 	p1y, "%s%sBack",	 			(selected1==6)?"^":" ", (selected2==6)?"_ ":"  " );
	
	g_Text.PrintVBT(p2x+=st, 	p2y, "%s%sPoints to win: %02d",	(selected2==1)?"_":" ", (selected1==1)?"^ ":"  ", WinAt );
	g_Text.PrintVBT(p2x+=st, 	p2y, "%s%sBall Spin:     %2.3f",(selected2==2)?"_":" ", (selected1==2)?"^ ":"  ", Ball.m_SpinAmt );
	g_Text.PrintVBT(p2x+=st, 	p2y, "%s%sBat Spring:    %2.3f",(selected2==3)?"_":" ", (selected1==3)?"^ ":"  ", Ball.m_AccVal );
	g_Text.PrintVTB(p2x+=st, 	p2y, "%s%sBat Speed:     %2.3f",(selected2==4)?"_":" ", (selected1==4)?"^ ":"  ", P1.m_Speeds.y);
	g_Text.PrintVTB(p2x+=st, 	p2y, "%s%sCPU Ability:   %03d",	(selected2==5)?"_":" ", (selected1==5)?"^ ":"  ", CPUIntelligence);
	g_Text.PrintVBT(p2x+=st,	p2y, "%s%sBack",				(selected2==6)?"_":" ", (selected1==6)?"^ ":"  " );
		
	switch(selected1)
	{								//	"------ SCREEN WIDTH -------"
		case 0:
			switch(Difficulty)
			{
			case 0:		g_Text.PrintVTB(56, 16, "    Fine tune settings     ");  				break;	
			case 1:		g_Text.PrintVTB(56, 16, "     The simplest game     "); 				break;	
			case 2:		g_Text.PrintVTB(56, 16, "   Make life interesting   "); 				break;	
			case 3:		g_Text.PrintVTB(56, 16, "      Getting harder       "); 				break;	
			case 4:		g_Text.PrintVTB(56, 16, "   Only for the hardcore   "); 				break;	
			default:	g_Text.PrintVTB(56, 16, "   You should never see    \n         this text         "); 	break;	
			}
			break;
		case 1:		g_Text.PrintVTB(56, 16, "  Points needed to win a   \n       single round        "); 	break;	
		case 2:		g_Text.PrintVTB(56, 16, "  Add spin if you hit the  \n    ball whilst moving     "); 	break;			
		case 3:		g_Text.PrintVTB(56, 16, "    How much faster the    \n ball gets after each hit  "); 	break;		
		case 4:		g_Text.PrintVTB(56, 16, "  How fast the bats move   "); 								break;	
		case 5:		g_Text.PrintVTB(56, 16, "  Lower value means smarter\n            CPU            "); 	break;	
		default: break;				  	
	}
	
	switch(selected2)
	{								//	"------ SCREEN WIDTH -------"
		case 0:
			switch(Difficulty)
			{															//	"------ SCREEN WIDTH -------"
			case 0:		g_Text.PrintVBT(SCREEN_WIDTH-64, SCREEN_HEIGHT-16, 	"    Fine tune settings     "); 				break;	
			case 1:		g_Text.PrintVBT(SCREEN_WIDTH-64, SCREEN_HEIGHT-16, 	"     The simplest game     "); 				break;	
			case 2:		g_Text.PrintVBT(SCREEN_WIDTH-64, SCREEN_HEIGHT-16, 	"   Make life interesting   "); 				break;	
			case 3:		g_Text.PrintVBT(SCREEN_WIDTH-64, SCREEN_HEIGHT-16, 	"      Getting harder       "); 				break;	
			case 4:		g_Text.PrintVBT(SCREEN_WIDTH-64, SCREEN_HEIGHT-16, 	"   Only for the hardcore   "); 				break;	
			default:	g_Text.PrintVBT(SCREEN_WIDTH-64, SCREEN_HEIGHT-16, 	"   You should never see    \n         this text         "); 	break;	
			}
			break;
		case 1:		g_Text.PrintVBT(SCREEN_WIDTH-64, SCREEN_HEIGHT-16, 		"  Points needed to win a   \n       single round        "); 	break;	
		case 2:		g_Text.PrintVBT(SCREEN_WIDTH-64, SCREEN_HEIGHT-16, 		"  Add spin if you hit the  \n    ball whilst moving     "); 	break;			
		case 3:		g_Text.PrintVBT(SCREEN_WIDTH-64, SCREEN_HEIGHT-16, 		"    How much faster the    \n ball gets after each hit  "); 	break;	
		case 4:		g_Text.PrintVBT(SCREEN_WIDTH-64, SCREEN_HEIGHT-16, 		"  How fast the bats move   "); 								break;	
		case 5:		g_Text.PrintVBT(SCREEN_WIDTH-64, SCREEN_HEIGHT-16, 		"  Lower value means smarter\n            CPU            "); 	break;	
		default: break;				  	
	}
		
		
	g_Text.PrintVTB(8, 2, 							   "^ Player 1");
	g_Text.PrintVBT(SCREEN_WIDTH-16, SCREEN_HEIGHT-10, "_ Player 2");

	return 1;
}


//==============================================================================
// About Menu Functions
//==============================================================================
int InputAbout(void* _arg)
{
	if((g_Core.m_Pad.Press & PSP_CTRL_LTRIGGER)	|| (g_Core.m_Pad.Press & PSP_CTRL_RTRIGGER)	)
	{
		g_pInput = &InputMenu;
		g_pLogic = &LogicMenu;
		g_pRender = &RenderMenu;
		selected1 = 0;
		selected2 = 0;
	}
	
	return 1;
}

int LogicAbout (void* _arg)
{
	return 1;		
}
int RenderAbout (void* _arg)
{

	
		
	//Render scene
	Playfield.Render();
	
	int t = 32;	
	int l = 8;	
	int p1x = (int)(SCREEN_WIDTH*0.5f-t);
	int p1y = (int)l;
	int p2x = (int)(SCREEN_WIDTH*0.5f+t);
	int p2y = (int)SCREEN_HEIGHT - l;
	int st = 10;
	
	//Render text
								//	"-------- SCREEN WIDTH -------"
	g_Text.PrintVTB(p1x, 	p1y, 	"Pong+");
	g_Text.PrintVTB(p1x-=st*2,p1y, 	"I made this in about a day   ");
	g_Text.PrintVTB(p1x-=st,p1y, 	"(not including the time to   ");
	g_Text.PrintVTB(p1x-=st,p1y, 	"make the libraries) to see   ");
	g_Text.PrintVTB(p1x-=st,p1y, 	"what making an entire (small)");
	g_Text.PrintVTB(p1x-=st,p1y, 	"PSP game involved, to say    ");
	g_Text.PrintVTB(p1x-=st,p1y, 	"that I could do it, and to   ");
	g_Text.PrintVTB(p1x-=st,p1y, 	"impress people at parties    ");
	g_Text.PrintVTB(p1x-=st,p1y, 	"with.  Any Problems/bugs/job ");
	g_Text.PrintVTB(p1x-=st,p1y, 	"offers, let me know:");
	g_Text.PrintVTB(p1x-=st,p1y, 	"fish.zapto.org");
	g_Text.PrintVTB(p1x-=st,p1y, 	"\t\t\t\t\t-Fish");
	g_Text.PrintVTB(p1x-=4*st,p1y, 	"\tPress L to continue");

	g_Text.PrintVBT(p2x, 	p2y, 	"Pong+");
	g_Text.PrintVBT(p2x+=st,p2y, 	"I made this in about a day,");
	g_Text.PrintVBT(p2x+=st,p2y, 	"(not including the time to   ");
	g_Text.PrintVBT(p2x+=st,p2y, 	"make the libraries) to see   ");
	g_Text.PrintVBT(p2x+=st,p2y, 	"what making an entire (small)");
	g_Text.PrintVBT(p2x+=st,p2y, 	"PSP game involved, to say    ");
	g_Text.PrintVBT(p2x+=st,p2y, 	"that I could do it, and to   ");
	g_Text.PrintVBT(p2x+=st,p2y, 	"impress people at parties    ");
	g_Text.PrintVBT(p2x+=st,p2y, 	"with.  Any Problems/bugs/job ");
	g_Text.PrintVBT(p2x+=st,p2y, 	"offers, let me know:");
	g_Text.PrintVBT(p2x+=st,p2y, 	"fish.zapto.org");
	g_Text.PrintVBT(p2x+=st,p2y, 	"\t\t\t\t\t-Fish");
	g_Text.PrintVTB(p2x+=4*st,p2y, 	"\tPress L to continue");

	g_Text.PrintVTB(8, 2, 							   "^ Player 1");
	g_Text.PrintVBT(SCREEN_WIDTH-16, SCREEN_HEIGHT-10, "_ Player 2");


	return 1;
}



//------------------------------------------------------------------------------
// Get Input
//------------------------------------------------------------------------------
int InputPaused(void* _arg)
{
	if(g_Core.m_Pad.Press & PSP_CTRL_RIGHT)		{	selected1--;	}
	if(g_Core.m_Pad.Press & PSP_CTRL_LEFT)		{	selected1++;	}
	if(g_Core.m_Pad.Press & PSP_CTRL_SQUARE)	{	selected2--;	}
	if(g_Core.m_Pad.Press & PSP_CTRL_CIRCLE)	{	selected2++;	}
	if((g_Core.m_Pad.Press & PSP_CTRL_LTRIGGER)	|| (g_Core.m_Pad.Press & PSP_CTRL_RTRIGGER)	)
	{
		int s;
		if(g_Core.m_Pad.Press & PSP_CTRL_RTRIGGER)	
			s = selected2;
		if(g_Core.m_Pad.Press & PSP_CTRL_LTRIGGER)	
			s = selected1;
			
		switch(s)
		{
		case 0:
			g_pInput = &InputGame;
			g_pLogic = &LogicGame;
			g_pRender = &RenderGame;
			selected1 = 0;
			selected2 = 0;
			break;
		case 1:
			g_pInput = &InputMenu;
			g_pLogic = &LogicMenu;
			g_pRender = &RenderMenu;
			selected1 = 0;
			selected2 = 0;
			break;
		default:	
			break;
		}
	}
	
	//Screen		
	if(g_Core.m_Pad.Press & PSP_CTRL_SELECT)
	{
		timeval s;
		timezone z;
		sceKernelLibcGettimeofday(&s, &z);
		
		char buf[64];
		sprintf(buf, "../../PHOTO/Pong+ [%ld].png", s.tv_sec);
		saveImage(buf, getVramDisplayBuffer(), SCREEN_WIDTH, SCREEN_HEIGHT, PSP_LINE_SIZE, 0);
	}

	return 1;
}

//------------------------------------------------------------------------------
// Think
//------------------------------------------------------------------------------
int LogicPaused(void* _arg)
{	
	(selected1 > maxPaused)?selected1 = 0:selected1=selected1;
	(selected1 < 0)?selected1 = maxPaused:selected1=selected1;
	(selected2 > maxPaused)?selected2 = 0:selected2=selected2;
	(selected2 < 0)?selected2 = maxPaused:selected2=selected2;
		
	return 1;		
}

//------------------------------------------------------------------------------
// Draw
//------------------------------------------------------------------------------
int RenderPaused(void* _arg)
{
	//Render scene
	Playfield.Render();
	
	int t = 56;	
	int l = 72;	
	int p1x = (int)(SCREEN_WIDTH*0.5f-t);
	int p1y = (int)l;
	int p2x = (int)(SCREEN_WIDTH*0.5f+t);
	int p2y = (int)SCREEN_HEIGHT - l;
	int st = 10;
	
	//Render text
	g_Text.PrintVTB(p1x,p1y, 		"   Paused");
	g_Text.PrintVTB(p1x-=2*st,p1y, 	"%s%sResume Game",	(selected1==0)?"^":" ", (selected2==0)?"_ ":"  " );
	g_Text.PrintVTB(p1x-=st,p1y, 	"%s%sEnd Game", 	(selected1==1)?"^":" ", (selected2==1)?"_ ":"  " );
	
	g_Text.PrintVBT(p2x,p2y, 		"   Paused");
	g_Text.PrintVBT(p2x+=2*st,p2y, 	"%s%sResume Game",	(selected2==0)?"_":" ", (selected1==0)?"^ ":"  " );
	g_Text.PrintVBT(p2x+=st,p2y, 	"%s%sEnd Game",		(selected2==1)?"_":" ", (selected1==1)?"^ ":"  " );
			
	g_Text.PrintVTB(8, 2, 							   "^ Player 1");
	g_Text.PrintVBT(SCREEN_WIDTH-16, SCREEN_HEIGHT-10, "_ Player 2");


	return 1;
}



//==============================================================================
// GAME WON FUNCTIONS
//==============================================================================
int InputGameWin	(void* _arg)
{	
	if((g_Core.m_Pad.Press & PSP_CTRL_LTRIGGER)	|| (g_Core.m_Pad.Press & PSP_CTRL_RTRIGGER)	)
	{	
		g_pInput = &InputMenu;
		g_pLogic = &LogicMenu;
		g_pRender = &RenderMenu;
	}

	return 1;
}

int LogicGameWin	(void* _arg)
{

	return 1;
}

int RenderGameWin	(void* _arg)
{

	
		
	//Render scene
	Playfield.Render();
	P1.Render();
	P2.Render();
	
	int t = 32;	
	int l = 56;	
	int p1x = (int)(SCREEN_WIDTH*0.5f-t);
	int p1y = (int)l;
	int p2x = (int)(SCREEN_WIDTH*0.5f+t);
	int p2y = (int)SCREEN_HEIGHT - l;
	int st = 18;
	
	//Render text
	int w = 0;
	if(P1.m_Score > P2.m_Score)
		w = 1;
	else
		w =2;
	
	g_Text.PrintVTB(p1x-=st, 	p1y, 	"%s Player %d Wins! %s", (w==1)?"^":"_", w, (w==1)?"^":"_" );	
	g_Text.PrintVTB(p1x-=st*2, 	p1y, 	"Score: ^ %02d - %02d _", P1.m_Score, P2.m_Score );
	g_Text.PrintVTB(p1x-=st, 	p1y, 	"Games: ^ %02d - %02d _", P1.m_ScoreGamesWon, P2.m_ScoreGamesWon );
	g_Text.PrintVTB(p1x-=st*3, 	p1y-4, 	"Press L to continue" );
	
	g_Text.PrintVBT(p2x+=st, 	p2y, 	"%s Player %d Wins! %s", (w==1)?"^":"_", w, (w==1)?"^":"_" );
	g_Text.PrintVBT(p2x+=st*2, 	p2y, 	"Score: _ %02d - %02d ^", P2.m_Score, P1.m_Score );
	g_Text.PrintVBT(p2x+=st, 	p2y, 	"Games: _ %02d - %02d ^", P2.m_ScoreGamesWon, P1.m_ScoreGamesWon );
	g_Text.PrintVBT(p2x+=st*3, 	p2y+4, 	"Press R to continue" );

	g_Text.PrintVTB(8, 2, 							   "^ Player 1");
	g_Text.PrintVBT(SCREEN_WIDTH-16, SCREEN_HEIGHT-10, "_ Player 2");

	return 1;
}
