#include <pspdisplay.h>	//screen output?
#include <pspkernel.h>	//kernel
#include <pspgu.h>
#include "sprite.h"
#include "../defines.h"

typedef struct
{
	unsigned short u, v;
	unsigned int c;
	short x, y, z;
} Vertex;

int CSprite::Init(char* _filename)
{
	
	m_Img = loadImage(_filename);
	
	if (!m_Img)
	{
		//printf("sprite load failed!\n");
		return 0;
	}
	
	x = 0;
	y = 0;
	w = m_Img->imageWidth;
	h = m_Img->imageHeight;	
	u = 0;
	v = 0;	
	col = RGBA(255,255,255,255);
	
	return 1;
}

int CSprite::Render()
{	
//	blitAlphaImageToScreen(u ,v ,w , h, m_Img, x, y);
	
	guStart();
	sceGuTexMode(GU_PSM_8888,0,0,0); // 16-bit RGBA
	sceGuTexImage(0, m_Img->textureWidth, m_Img->textureHeight, m_Img->textureWidth, (void*) m_Img->data);
	float u = 1.0f / ((float)m_Img->textureWidth);
	float v = 1.0f / ((float)m_Img->textureHeight);
	sceGuTexScale(u, v);
	sceGuTexFunc(GU_TFX_MODULATE, GU_TCC_RGBA); 
	
		// Get 2 new vertices (tl/br)
		Vertex* vertices = (Vertex*) sceGuGetMemory(2 * sizeof(Vertex));
		
		// Fill vertices with data
		vertices[0].x = x;
		vertices[0].y = y;
		vertices[0].z = 0;
		vertices[0].u = u;
		vertices[0].v = v;	
		vertices[0].c = col;
								
		vertices[1].x = x + w;
		vertices[1].y = y + h;	
		vertices[1].z = 0;
		vertices[1].u = u + w;
		vertices[1].v = v + h;	
		vertices[1].c = col;
		
		sceGuDrawArray(GU_SPRITES, GU_TEXTURE_16BIT |GU_COLOR_8888| GU_VERTEX_16BIT | GU_TRANSFORM_2D, 2, 0, vertices);

	
	sceGuFinish();
	sceGuSync(0, 0);
	
	return 1;
}

		
